]> git.proxmox.com Git - mirror_qemu.git/blob - scripts/qemu-binfmt-conf.sh
qemu-binfmt-conf.sh: add persistent (F) flags
[mirror_qemu.git] / scripts / qemu-binfmt-conf.sh
1 #!/bin/sh
2 # enable automatic i386/ARM/M68K/MIPS/SPARC/PPC/s390/HPPA/Xtensa/microblaze
3 # program execution by the kernel
4
5 qemu_target_list="i386 i486 alpha arm armeb sparc32plus ppc ppc64 ppc64le m68k \
6 mips mipsel mipsn32 mipsn32el mips64 mips64el \
7 sh4 sh4eb s390x aarch64 aarch64_be hppa riscv32 riscv64 xtensa xtensaeb microblaze microblazeel"
8
9 i386_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x03\x00'
10 i386_mask='\xff\xff\xff\xff\xff\xfe\xfe\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
11 i386_family=i386
12
13 i486_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x06\x00'
14 i486_mask='\xff\xff\xff\xff\xff\xfe\xfe\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
15 i486_family=i386
16
17 alpha_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x26\x90'
18 alpha_mask='\xff\xff\xff\xff\xff\xfe\xfe\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
19 alpha_family=alpha
20
21 arm_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x28\x00'
22 arm_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
23 arm_family=arm
24
25 armeb_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x28'
26 armeb_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
27 armeb_family=armeb
28
29 sparc_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x02'
30 sparc_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
31 sparc_family=sparc
32
33 sparc32plus_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x12'
34 sparc32plus_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
35 sparc32plus_family=sparc
36
37 ppc_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x14'
38 ppc_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
39 ppc_family=ppc
40
41 ppc64_magic='\x7fELF\x02\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x15'
42 ppc64_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
43 ppc64_family=ppc
44
45 ppc64le_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x15\x00'
46 ppc64le_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\x00'
47 ppc64le_family=ppcle
48
49 m68k_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x04'
50 m68k_mask='\xff\xff\xff\xff\xff\xff\xfe\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
51 m68k_family=m68k
52
53 # FIXME: We could use the other endianness on a MIPS host.
54
55 mips_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08'
56 mips_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
57 mips_family=mips
58
59 mipsel_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08\x00'
60 mipsel_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
61 mipsel_family=mips
62
63 mipsn32_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08'
64 mipsn32_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
65 mipsn32_family=mips
66
67 mipsn32el_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08\x00'
68 mipsn32el_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
69 mipsn32el_family=mips
70
71 mips64_magic='\x7fELF\x02\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08'
72 mips64_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
73 mips64_family=mips
74
75 mips64el_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08\x00'
76 mips64el_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
77 mips64el_family=mips
78
79 sh4_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x2a\x00'
80 sh4_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
81 sh4_family=sh4
82
83 sh4eb_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x2a'
84 sh4eb_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
85 sh4eb_family=sh4
86
87 s390x_magic='\x7fELF\x02\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x16'
88 s390x_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
89 s390x_family=s390x
90
91 aarch64_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xb7\x00'
92 aarch64_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
93 aarch64_family=arm
94
95 aarch64_be_magic='\x7fELF\x02\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xb7'
96 aarch64_be_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
97 aarch64_be_family=armeb
98
99 hppa_magic='\x7f\x45\x4c\x46\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x0f'
100 hppa_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
101 hppa_family=hppa
102
103 riscv32_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xf3\x00'
104 riscv32_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
105 riscv32_family=riscv
106
107 riscv64_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xf3\x00'
108 riscv64_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
109 riscv64_family=riscv
110
111 xtensa_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x5e\x00'
112 xtensa_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
113 xtensa_family=xtensa
114
115 xtensaeb_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x5e'
116 xtensaeb_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
117 xtensaeb_family=xtensaeb
118
119 microblaze_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xba\xab'
120 microblaze_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
121 microblaze_family=microblaze
122
123 microblazeel_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xab\xba'
124 microblazeel_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
125 microblazeel_family=microblazeel
126
127 qemu_get_family() {
128 cpu=${HOST_ARCH:-$(uname -m)}
129 case "$cpu" in
130 amd64|i386|i486|i586|i686|i86pc|BePC|x86_64)
131 echo "i386"
132 ;;
133 mips*)
134 echo "mips"
135 ;;
136 "Power Macintosh"|ppc64|powerpc|ppc)
137 echo "ppc"
138 ;;
139 ppc64el|ppc64le)
140 echo "ppcle"
141 ;;
142 arm|armel|armhf|arm64|armv[4-9]*l|aarch64)
143 echo "arm"
144 ;;
145 armeb|armv[4-9]*b|aarch64_be)
146 echo "armeb"
147 ;;
148 sparc*)
149 echo "sparc"
150 ;;
151 riscv*)
152 echo "riscv"
153 ;;
154 *)
155 echo "$cpu"
156 ;;
157 esac
158 }
159
160 usage() {
161 cat <<EOF
162 Usage: qemu-binfmt-conf.sh [--qemu-path PATH][--debian][--systemd CPU]
163 [--help][--credential yes|no][--exportdir PATH]
164 [--persistent yes|no]
165
166 Configure binfmt_misc to use qemu interpreter
167
168 --help: display this usage
169 --qemu-path: set path to qemu interpreter ($QEMU_PATH)
170 --debian: don't write into /proc,
171 instead generate update-binfmts templates
172 --systemd: don't write into /proc,
173 instead generate file for systemd-binfmt.service
174 for the given CPU. If CPU is "ALL", generate a
175 file for all known cpus
176 --exportdir: define where to write configuration files
177 (default: $SYSTEMDDIR or $DEBIANDIR)
178 --credential: if yes, credential and security tokens are
179 calculated according to the binary to interpret
180 --persistent: if yes, the interpreter is loaded when binfmt is
181 configured and remains in memory. All future uses
182 are cloned from the open file.
183
184 To import templates with update-binfmts, use :
185
186 sudo update-binfmts --importdir ${EXPORTDIR:-$DEBIANDIR} --import qemu-CPU
187
188 To remove interpreter, use :
189
190 sudo update-binfmts --package qemu-CPU --remove qemu-CPU $QEMU_PATH
191
192 With systemd, binfmt files are loaded by systemd-binfmt.service
193
194 The environment variable HOST_ARCH allows to override 'uname' to generate
195 configuration files for a different architecture than the current one.
196
197 where CPU is one of:
198
199 $qemu_target_list
200
201 EOF
202 }
203
204 qemu_check_access() {
205 if [ ! -w "$1" ] ; then
206 echo "ERROR: cannot write to $1" 1>&2
207 exit 1
208 fi
209 }
210
211 qemu_check_bintfmt_misc() {
212 # load the binfmt_misc module
213 if [ ! -d /proc/sys/fs/binfmt_misc ]; then
214 if ! /sbin/modprobe binfmt_misc ; then
215 exit 1
216 fi
217 fi
218 if [ ! -f /proc/sys/fs/binfmt_misc/register ]; then
219 if ! mount binfmt_misc -t binfmt_misc /proc/sys/fs/binfmt_misc ; then
220 exit 1
221 fi
222 fi
223
224 qemu_check_access /proc/sys/fs/binfmt_misc/register
225 }
226
227 installed_dpkg() {
228 dpkg --status "$1" > /dev/null 2>&1
229 }
230
231 qemu_check_debian() {
232 if [ ! -e /etc/debian_version ] ; then
233 echo "WARNING: your system is not a Debian based distro" 1>&2
234 elif ! installed_dpkg binfmt-support ; then
235 echo "WARNING: package binfmt-support is needed" 1>&2
236 fi
237 qemu_check_access "$EXPORTDIR"
238 }
239
240 qemu_check_systemd() {
241 if ! systemctl -q is-enabled systemd-binfmt.service ; then
242 echo "WARNING: systemd-binfmt.service is missing or disabled" 1>&2
243 fi
244 qemu_check_access "$EXPORTDIR"
245 }
246
247 qemu_generate_register() {
248 flags=""
249 if [ "$CREDENTIAL" = "yes" ] ; then
250 flags="OC"
251 fi
252 if [ "$PERSISTENT" = "yes" ] ; then
253 flags="${flags}F"
254 fi
255
256 echo ":qemu-$cpu:M::$magic:$mask:$qemu:$flags"
257 }
258
259 qemu_register_interpreter() {
260 echo "Setting $qemu as binfmt interpreter for $cpu"
261 qemu_generate_register > /proc/sys/fs/binfmt_misc/register
262 }
263
264 qemu_generate_systemd() {
265 echo "Setting $qemu as binfmt interpreter for $cpu for systemd-binfmt.service"
266 qemu_generate_register > "$EXPORTDIR/qemu-$cpu.conf"
267 }
268
269 qemu_generate_debian() {
270 cat > "$EXPORTDIR/qemu-$cpu" <<EOF
271 package qemu-$cpu
272 interpreter $qemu
273 magic $magic
274 mask $mask
275 credential $CREDENTIAL
276 EOF
277 }
278
279 qemu_set_binfmts() {
280 # probe cpu type
281 host_family=$(qemu_get_family)
282
283 # register the interpreter for each cpu except for the native one
284
285 for cpu in ${qemu_target_list} ; do
286 magic=$(eval echo \$${cpu}_magic)
287 mask=$(eval echo \$${cpu}_mask)
288 family=$(eval echo \$${cpu}_family)
289
290 if [ "$magic" = "" ] || [ "$mask" = "" ] || [ "$family" = "" ] ; then
291 echo "INTERNAL ERROR: unknown cpu $cpu" 1>&2
292 continue
293 fi
294
295 qemu="$QEMU_PATH/qemu-$cpu"
296 if [ "$cpu" = "i486" ] ; then
297 qemu="$QEMU_PATH/qemu-i386"
298 fi
299
300 if [ "$host_family" != "$family" ] ; then
301 $BINFMT_SET
302 fi
303 done
304 }
305
306 CHECK=qemu_check_bintfmt_misc
307 BINFMT_SET=qemu_register_interpreter
308
309 SYSTEMDDIR="/etc/binfmt.d"
310 DEBIANDIR="/usr/share/binfmts"
311
312 QEMU_PATH=/usr/local/bin
313 CREDENTIAL=no
314 PERSISTENT=no
315
316 options=$(getopt -o ds:Q:e:hc:p: -l debian,systemd:,qemu-path:,exportdir:,help,credential:,persistent: -- "$@")
317 eval set -- "$options"
318
319 while true ; do
320 case "$1" in
321 -d|--debian)
322 CHECK=qemu_check_debian
323 BINFMT_SET=qemu_generate_debian
324 EXPORTDIR=${EXPORTDIR:-$DEBIANDIR}
325 ;;
326 -s|--systemd)
327 CHECK=qemu_check_systemd
328 BINFMT_SET=qemu_generate_systemd
329 EXPORTDIR=${EXPORTDIR:-$SYSTEMDDIR}
330 shift
331 # check given cpu is in the supported CPU list
332 if [ "$1" != "ALL" ] ; then
333 for cpu in ${qemu_target_list} ; do
334 if [ "$cpu" = "$1" ] ; then
335 break
336 fi
337 done
338
339 if [ "$cpu" = "$1" ] ; then
340 qemu_target_list="$1"
341 else
342 echo "ERROR: unknown CPU \"$1\"" 1>&2
343 usage
344 exit 1
345 fi
346 fi
347 ;;
348 -Q|--qemu-path)
349 shift
350 QEMU_PATH="$1"
351 ;;
352 -e|--exportdir)
353 shift
354 EXPORTDIR="$1"
355 ;;
356 -h|--help)
357 usage
358 exit 1
359 ;;
360 -c|--credential)
361 shift
362 CREDENTIAL="$1"
363 ;;
364 -p|--persistent)
365 shift
366 PERSISTENT="$1"
367 ;;
368 *)
369 break
370 ;;
371 esac
372 shift
373 done
374
375 $CHECK
376 qemu_set_binfmts